#ifndef API_H
#define API_H 1

#ifdef EXT_C
#define EC extern "C"
#else
#define EC
#endif

#define DK_LEN 192

#define WHIRLPOOL_DIGEST_SIZE   64
#define WHIRLPOOL_BLOCK_SIZE    64

typedef union
{
    unsigned int  state[16];
    unsigned char state_c[64];
} whirlpool_shared_state_t;

typedef struct
{
    union
    {
        unsigned char c[WHIRLPOOL_BLOCK_SIZE];
        unsigned int  i[WHIRLPOOL_BLOCK_SIZE/sizeof(int)];
    } buf;
    whirlpool_shared_state_t s;
    unsigned int length;
    unsigned int curlen;
} whirlpool_state_t;

void setup_whirlpool_kernel();
void get_dk_whirlpool();
#endif
